package animals;

abstract class Animal implements ISoundable {
    //  read-only property
    public String getName() {
        return this.name;
    }
    private String name;
    
    //  read-only property
    public boolean getIsAsleep() {
        return this.isAsleep;
    }
    private boolean isAsleep;
    
    //          
    protected Animal(String name) throws AnimalException {
        //         
        if(name == null || name.equals(""))
            throw new AnimalException("       !");
        this.name = name;
        
        System.out.println("   : " + this.name);
    }
    protected Animal(String name, boolean isAsleep) throws AnimalException {
        //         
        if(name == null || name.equals(""))
            throw new AnimalException("       !");
        this.name = name;
        this.isAsleep = isAsleep;
        
        System.out.println("   : " + this.name);
    }
    
    //   
    public void sleep() throws AnimalException {
        if (this.isAsleep)
            throw new AnimalException("  .");
        
        System.out.println(" .");
    }
    
    //   
    public void wakeUp() throws AnimalException {
        if (this.isAsleep)
            throw new AnimalException("   .");
        
        System.out.println("  .");
    }
    
    // ISoundable Members
    public abstract void sound();
}