package animals;

public class Main {
    public static void main(String[] args) throws java.io.IOException, AnimalException {
        Animal animal;
        
        //!  Animal        
        // animal = new Animal("");
        //!    Cat  private       
        // animal = new Cat("");
        
        try {
            Animal unnamedAnimal = new Dog(null, true);
            System.out.println(unnamedAnimal.getName());
        } catch (AnimalException ex) {
            //    ,   /exception    -
            //     AnimalException     
            System.out.println("    , : " + ex.getMessage());
        } finally {
            //     ,    ,  catch 
            //  .
            System.out.println("    !");
        }
        
        ISoundable soundable;
        
        //   (Dog)   "".    ,  animal  
        //  Animal, ..   (..  )    (typecast)
        animal = new Dog("");
        
        //   typecast,       
        System.out.println("    : " + animal.getClass());
        
        soundable = (ISoundable)animal;
        soundable.sound();
        
        //   -  ,      
        //  :
        for(int i = 0;; i++) {
            try {
                animal = Cat.createCat(" #" + (i + 1));
                animal.sound();
            } catch (AnimalException ex) {
                //       ,   
                System.out.println(" .   " + Cat.getTotalCats() + " !");
                break;
            }
        }
        
        // Alien       Dog, Cat  Animal,  , 
        //  ISoundable  ,    ,    sound().
        Alien alien = new Alien();
        soundable = (ISoundable)alien;
        soundable.sound();
        
        System.in.read();
    }
}
